NAME = libbacktrace

libbacktrace_SOURCES = \
          Backtrace.cpp \
          BacktraceCurrent.cpp \
          BacktraceMap.cpp \
          BacktracePtrace.cpp \
          ThreadEntry.cpp \
          UnwindMap.cpp \
          UnwindStack.cpp \
          UnwindStackMap.cpp \

libunwindstack_SOURCES := \
        ArmExidx.cpp \
        DwarfCfa.cpp \
        DwarfEhFrameWithHdr.cpp \
        DwarfMemory.cpp \
        DwarfOp.cpp \
        DwarfSection.cpp \
        Elf.cpp \
        ElfInterfaceArm.cpp \
        Global.cpp \
        JitDebug.cpp \
        Log.cpp \
        MapInfo.cpp \
        Maps.cpp \
        Memory.cpp \
        LocalUnwinder.cpp \
        Regs.cpp \
        RegsArm.cpp \
        RegsArm64.cpp \
        RegsX86.cpp \
        RegsX86_64.cpp \
        RegsMips.cpp \
        RegsMips64.cpp \
        Unwinder.cpp \
        Symbols.cpp \

demangle_srcs = demangle/Demangler.cpp

SOURCES = \
  $(foreach source, $(filter %.cpp, $(libbacktrace_SOURCES)), libbacktrace/$(source)) \
  $(foreach source, $(filter %.cpp, $(libunwindstack_SOURCES)), libunwindstack/$(source)) \
  $(demangle_srcs)

CXXOBJECTS = $(SOURCES:.cpp=.o)
CXXFLAGS += -c -std=gnu++2a -fno-omit-frame-pointer -fPIC
CPPFLAGS += \
            -Iinclude \
            -Ibase/include \
            -Idemangle/include \
            -Ilibprocinfo/include \
            -Ilibunwindstack/include \
            -I/usr/include/android/lzma \
            -I/usr/include/android/unwind
LDFLAGS += -shared -Wl,-soname,$(NAME).so.0 \
           -Wl,-rpath=/usr/lib/$(DEB_HOST_MULTIARCH)/android \
           -L/usr/lib/$(DEB_HOST_MULTIARCH)/android -lunwind \
           -L. -lbase -llog -lcutils -lpthread -llzma

build: $(COBJECTS) $(CXXOBJECTS)
	$(CXX) $^ -o $(NAME).so.0 $(LDFLAGS)
	ln -s $(NAME).so.0 $(NAME).so

clean:
	$(RM) $(COBJECTS) $(CXXOBJECTS) $(NAME).so*

$(CXXOBJECTS): %.o: %.cpp
	$(CXX) $< -o $@ $(CXXFLAGS) $(CPPFLAGS)

$(COBJECTS): %.o: %.c
	$(CC) $< -o $@ $(CFLAGS) $(CPPFLAGS)
